/**
 * Proiect PM - Control-bt
 * Authors: Mihai Dumitrache <mihai  [at] wip.ro>
 *          Alex Eftimie <alex [at] eftimie.ro>
 * Copyright: GPL V2
 */

package hello;

import java.io.*;

import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/* Mesaje
 *
 * @echo01
 * @screen
 * @lock
 * @unlock
 * @site
 * @msg Proiect PM
 */
public class HelloMIDlet extends MIDlet implements CommandListener
{
    private boolean midletPaused = false;

    private Command exitCommand;
    private Form form;
    private StringItem stringItem;

    private Command startCommand;
    private Command echoCommand;
    private Command screenCommand;
    private Command lockCommand;
    private Command unlockCommand;
    private Command siteCommand;
    private Command msgCommand;
    
    public HelloMIDlet() {
    }

    private void initialize() {
    }
    public InputStreamReader reader;
    public DataOutputStream writer;
    public StreamConnection connection;

    public void startMIDlet() {
        switchDisplayable(null, getForm());

    }
    public void resumeMIDlet() {
    }

    public void switchDisplayable(Alert alert, Displayable nextDisplayable) {
        Display display = getDisplay();
        if (alert == null) {
            display.setCurrent(nextDisplayable);
        } else {
            display.setCurrent(alert, nextDisplayable);
        }
    }

    private void sendMessage(String message) {
        try {
            writer.writeChars(message);
            writer.writeChar(10);
            writer.flush();
            form.append("M: " + message + "\n");
        }
        catch (IOException e) {
            form.append("Error" + e.getMessage());
        }
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (displayable == form) {
            if (command == exitCommand) {
                exitMIDlet();
            } else if (command == startCommand) {
                connectToBT();
            }            
            else if (command == echoCommand) {
                sendMessage("@echo01 ");
            }
            else if (command == screenCommand) {
                sendMessage("@screen ");
            }
            else if (command == lockCommand) {
                sendMessage("@lock ");
            }
            else if (command == unlockCommand) {
                sendMessage("@unlock ");
            }
            else if (command == siteCommand) {
                sendMessage("@site ");
            }
            else if (command == msgCommand) {
                sendMessage("@msg Proiect PM");
            }
        }
        
    }

    public void connectToBT() {
        String url = "btspp://00019507498D:1";
        try {
            connection = (StreamConnection) Connector.open(url, Connector.READ_WRITE);
            form.append("Connected\n");
            reader = new InputStreamReader(connection.openInputStream());
            form.append("InStream aquired\n");
            writer = new DataOutputStream(connection.openDataOutputStream());
            form.append("OutStream aquired\n");
        }
        catch (Exception e) {
            form.append("Error" + e.getMessage());
        }
    }

    public Command getExitCommand() {
        if (exitCommand == null) {
            exitCommand = new Command("Exit", Command.EXIT, 0);            
        }
        return exitCommand;
    }

    public Form getForm() {
        if (form == null) {
            form = new Form("Welcome", new Item[] { getStringItem() });
            form.addCommand(getExitCommand());
            form.setCommandListener(this);
            startCommand = new Command("Connect", Command.ITEM, 0);
            echoCommand = new Command("Echo", Command.ITEM, 0);
            screenCommand = new Command("Screen", Command.ITEM, 0);
            lockCommand = new Command("Lock", Command.ITEM, 0);
            unlockCommand = new Command("Unlock", Command.ITEM, 0);
            siteCommand = new Command("Site", Command.ITEM, 0);
            msgCommand = new Command("Msg", Command.ITEM, 0);

            form.addCommand(startCommand);
            form.addCommand(echoCommand);
            form.addCommand(screenCommand);
            form.addCommand(lockCommand);
            form.addCommand(unlockCommand);
            form.addCommand(siteCommand);
            form.addCommand(msgCommand);
        }
        return form;
    }
    
    public StringItem getStringItem() {
        if (stringItem == null) {
            stringItem = new StringItem("Control-BT", "Proiect PM");
        }
        return stringItem;
    }
    
    public Display getDisplay () {
        return Display.getDisplay(this);
    }

    public void exitMIDlet() {
        try {
        reader.close();
        writer.close();
        connection.close();
        }
        catch (Exception e) {
        }

        switchDisplayable (null, null);
        destroyApp(true);
        notifyDestroyed();
    }

    public void startApp() {
        if (midletPaused) {
            resumeMIDlet ();
        } else {
            initialize ();
            startMIDlet ();
        }
        midletPaused = false;
    }

    public void pauseApp() {
        midletPaused = true;
    }

    public void destroyApp(boolean unconditional) {
    }
}