/**
 * PROIECT PM - Control-bt
 * Authors: Mihai Dumitrache <mihai [at] wip.ro>
 * 			Alex Eftimie <alex [at] eftimie.ro>
 * Copyright: GPL V2
 */
#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "seriala.h"

void
usart_init()
{
	UBRRH = (uint8_t)(UART_BAUD_CALC(UART_BAUD_RATE,F_OSC)>>8);
	UBRRL = (uint8_t)UART_BAUD_CALC(UART_BAUD_RATE,F_OSC);

	UCSRB = (1<<RXCIE) | (1 << RXEN) | (1 << TXEN);
	UCSRC = (1 << URSEL) | (3 << UCSZ0);	
}

char
uart_getchar()
{
	while ( !(UCSRA & (1<<RXC)) )
		  ;
	return UDR;
}

char
uart_putchar(char c)      
{
	while ( !( UCSRA & (1<<UDRE)) )
		  ;
	UDR = c;
	return 0;
}
