#!/usr/bin/env python
# encoding=utf-8
# PM - eftdum
# daemon remote control
#
# for documentation refer to: http://elf.cs.pub.ro/pm/wiki/doku.php?id=pm:prj2009:cc:control-bt#protocol_de_comunicare
#
# Authors: Alex Eftimie <alex [at] eftimie.ro> 
# 		   Mihai Dumitrache <mihai [at] wip.ro> 
# Copyright: GPL V2

import sys, os, os.path, time
import socket
import notifications
import webbrowser
import gtk, gtk.gdk
from threading import Thread

DELAY = 1
#HOST = '0.0.0.0'		# use it for UDP broadcasting
#HOST = '192.169.1.99'	# tcp ajax magic
HOST = '192.168.1.99'
GET = '//x.htm'
PORT = 80			# eftdu 33838
buf  = 220

def si_show_about(event):
	ad = gtk.AboutDialog()
	icon = gtk.gdk.pixbuf_new_from_file("icons/tango_bluetooth_48.png")
	ad.set_logo(icon)
	ad.set_name("Control Bluetooth")
	ad.set_authors(["Mihai Dumitrache <mihai@wip.ro>","Alex Eftimie <alex@eftimie.ro>"])
	ad.set_comments("Daemon care interoghează superplăcuța și controlează apoi computerul.")
	ad.set_version('0.2')
	ad.run()
	ad.destroy()
    
def si_menu_show(widget, button, time, data = None):
    if button == 3:
        if data:
            data.show_all()
            data.popup(None, None, None, 3, time)
    pass
def si_quit(event):
	global gata
	gata = True
	gtk.main_quit();
	sys.exit(0)
	
def si_init():
	si = gtk.StatusIcon()
	icon = gtk.gdk.pixbuf_new_from_file("icons/tango_bluetooth_16.png")
	si.set_from_pixbuf(icon)
	si.set_tooltip("Control Bluetooth")

	menu = gtk.Menu()
	menuItem = gtk.ImageMenuItem(gtk.STOCK_ABOUT)
	menuItem.connect('activate', si_show_about)
	menu.append(menuItem)
	menuItem = gtk.ImageMenuItem(gtk.STOCK_QUIT)
	menuItem.connect('activate', si_quit)
	menu.append(menuItem)

	#si.connect('activate', si_facebook)
	si.connect('popup-menu', si_menu_show, menu)
	si.set_visible(True)
	gtk.main()
	
def grab_keyboard():
	global win
	result = gtk.gdk.keyboard_grab(win)
	if result != gtk.gdk.GRAB_SUCCESS:
		print "[eroare] tastatura", result

def ungrab_keyboard():
	gtk.gdk.keyboard_ungrab()
	
def parse_data(data):
	global gata, notif
	# scot HTML shite
	linii = data.split("\n")
	data = linii[3][:-1]
	if data[0:4] == "exit":
		gata = True;gtk.main_quit();
	elif data[0:3] == "msg":
		notif.show_notify("Receptionat", data[3:], None)
	elif data[0:4] == "echo":
		notif.show_notify("Control Bluetooth", "Perfect funcțional. Versiunea %s" % data[4:], None)
	elif data[0:6] == "screen":
		os.system("gnome-screensaver-command --lock")
	elif data[0:4] == "lock":
		win.show()
		# sleep until window is shown
		time.sleep(0.5)
		notif.show_notify("Control Bluetooth", "Tastatura a fost blocată", None)
		grab_keyboard()		
	elif data[0:6] == "unlock":
		notif.show_notify("Control Bluetooth", "Tastatura a fost deblocată", None)
		ungrab_keyboard()
		time.sleep(1)
		win.hide()
	elif data[0:4] == "site":
		webbrowser.open('http://alex.eftimie.ro/')
	elif data == "NOPE":
		print "Nope."
	else:
		print "TODO", data
		notif.show_notify("Necunoscut", data, None)

class Network(Thread):
	def run(self):
		global gata, HOST, PORT, GET
		while not gata:
			s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			print "Trying to connect to host..."
			s.connect((HOST, PORT))
			s.send("GET %s HTTP/1.0\r\nHost: %s\r\n\r\n" % (GET, HOST))
			data = s.recv(1024)
			#print 'Mesaj receptionat : ', data
			sir = data
			while len(data):
				data = s.recv(1024)
				sir = sir + data
			parse_data(sir)
			print 'Done'
			time.sleep(DELAY)
			s.close()
		pass

	''' run udp. not used any more '''
	def run_udp(self):
		global gata
		sUDP = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
		sUDP.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
		sUDP.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
		try:
			sUDP.bind((HOST, PORT))
		except socket.error, msg:
			print "Eroare", msg
			sys.exit(-1)

		s = sUDP
		gata = False
		while not gata:
			data, addr = s.recvfrom(buf)
			print 'Mesaj de la ', addr, ' : ', data
			if not data: break
			parse_data(data)
			time.sleep(0.4)
			print 'Done', addr
		s.close()

if __name__ == "__main__":
	os.chdir(os.path.dirname(os.path.abspath( __file__ )))
	notif = notifications.Notification()
	n = Network()
	# lucru cu threaduri+gtk
	gtk.gdk.threads_init()
	gata = False
	n.start()
	
	win = gtk.gdk.Window(gtk.gdk.get_default_root_window(), 100, 20, gtk.gdk.WINDOW_TOPLEVEL, gtk.gdk.ALL_EVENTS_MASK, gtk.gdk.INPUT_ONLY)
	win.show()
	win.hide()
	si_init()
